"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var path = _interopRequireWildcard(require("path"));

var _resolveAsBin = require("./utils/resolve-as-bin");

var _getModularRoot = _interopRequireDefault(require("./utils/getModularRoot"));

var _actionPreflightCheck = _interopRequireDefault(require("./utils/actionPreflightCheck"));

var _isModularType = _interopRequireDefault(require("./utils/isModularType"));

var _execSync = _interopRequireDefault(require("./utils/execSync"));

var _stageView = _interopRequireDefault(require("./utils/stageView"));

var _config = require("./config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function start(target) {
  const modularRoot = (0, _getModularRoot.default)();
  const targetPath = path.join(modularRoot, _config.packagesRoot, target);

  if ((0, _isModularType.default)(targetPath, 'package')) {
    throw new Error(`The package at ${targetPath} is not a valid modular app or view.`);
  }

  const cracoBin = await (0, _resolveAsBin.resolveAsBin)('@craco/craco');
  let startPath = path.join(modularRoot, _config.packagesRoot, target);

  if ((0, _isModularType.default)(targetPath, 'view')) {
    const stagedView = (0, _stageView.default)(modularRoot, target);
    startPath = stagedView;
  }

  (0, _execSync.default)(cracoBin, ['start', '--config', _config.cracoConfig], {
    cwd: startPath,
    log: false,
    // @ts-ignore
    env: {
      USE_MODULAR_BABEL: process.env.USE_MODULAR_BABEL,
      MODULAR_ROOT: modularRoot,
      SKIP_PREFLIGHT_CHECK: 'true'
    }
  });
  return Promise.resolve();
}

var _default = (0, _actionPreflightCheck.default)(start);

exports.default = _default;