"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.log = log;
exports.warn = warn;
exports.error = error;
exports.debug = debug;

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable @typescript-eslint/no-explicit-any */
const prefix = '[modular] ';
const DEBUG = process.env.MODULAR_LOGGER_DEBUG;
const SILENT = process.env.MODULAR_LOGGER_MUTE;

function print(x) {
  if (SILENT) {
    return;
  }

  process.stderr.write(_chalk.default.dim(prefix) + x + '\n');
}

function log(...x) {
  print(x.join(' '));
}

function warn(...x) {
  print(_chalk.default.yellow(x.join(' ')));
}

function error(...x) {
  print(_chalk.default.red(x.join(' ')));
}

function debug(...x) {
  if (DEBUG) {
    log(...x);
  }
}